package
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.display.PixelSnapping;
	
	/**
	 * bitmapを分割してリストで返すためのクラス(CopyPixelsを使用).
	 * 
	 * 参考ページ
	 * ActionScriptでイメージのスライス。 | almondlab. | Web Design, Graphic Design, FLASH, CMS
	 * http://www.almondlab.jp/labs/499
	 */
	public class BmpSliceCopyPixels
	{
		private var orgBmp:Bitmap;
		private var bmpList:Array;
		
		public function BmpSliceCopyPixels(bmp:Bitmap)
		{
			orgBmp = bmp;
		}
		
		/**
		 * 分割したbitmapリストを取得する.
		 *
		 * @param	xdiv	横分割数
		 * @param	ydiv	縦分割数
		 * @return	分割されたbitmapリスト
		 */
		public function getSliceBmpList(xdiv:int = 1, ydiv:int = 1):Array
		{
			var w:Number = orgBmp.width / xdiv;
			var h:Number = orgBmp.height / ydiv;
			bmpList = new Array();
			
			var orgBmpData:BitmapData = new BitmapData(orgBmp.width, orgBmp.height, true);
			orgBmpData.draw(orgBmp);
			
			for (var y:int = 0; y < ydiv; y++)
			{
				for (var x:int = 0; x < xdiv; x++)
				{
					var rect:Rectangle = new Rectangle(w * x, h * y, w, h);
					var bmpData:BitmapData = new BitmapData(w, h, true);
					var bmp:Bitmap = new Bitmap();
					
					// 元画像からコピー
					bmpData.copyPixels(orgBmpData, rect, new Point());
					bmp.bitmapData = bmpData;
					bmp.pixelSnapping = PixelSnapping.NEVER;
					bmp.smoothing = true;
					
					// 本来の表示位置を記録
					bmp.x = rect.x;
					bmp.y = rect.y;
					
					bmpList.push(bmp);
				}
			}
			
			return bmpList;
		}
	}

}