package
{
	import flash.display.Bitmap;
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.geom.Point;
	
	/**
	 * 分割画像1枚分のスプライト
	 */
	public class MySprite extends Sprite
	{
		private var myBmp:Bitmap;
		private var step:int;
		private var count:int;
		private var waitCount:int;
		private var tgt:Point;
		
		public function MySprite(bmp:Bitmap, sx:Number, sy:Number, lcnt:int, wcnt:int)
		{
			myBmp = bmp;
			addChild(myBmp);
			
			// 画像幅取得
			var w:int = myBmp.width;
			var h:int = myBmp.height;
			
			// 画像の表示位置取得
			var ox:int = myBmp.x;
			var oy:int = myBmp.y;
			
			// 制御位置を画像を中心にするため補正
			myBmp.x = -(w / 2);
			myBmp.y = -(h / 2);
			
			// 本来の表示位置を記録
			tgt = new Point((w / 2) + ox + sx, (h / 2) + oy + sy);
			
			// 拡大縮小を0に
			this.scaleX = 0.0;
			this.scaleY = 0.0;
			
			// 初期座標値をランダムに設定
			setPosRnd();
			
			step = 0;
			count = lcnt;
			waitCount = wcnt;
		}
		
		public function setPosRnd():void
		{
			var w:Number = 640;
			var h:Number = 400;
			if (false)
			{
				this.x = Math.random() * (w * 3) - w;
				this.y = Math.random() * (h * 3) - h;
			}
			else
			{
				this.x = tgt.x + w;
				this.y = tgt.y;
			}
		}
		
		/**
		 * 毎フレーム行うべき処理
		 */
		public function enterFrame():void
		{
			var d:Number = 0.05;
			
			switch (step)
			{
				case 0: 
					// 時間待ち
					if (this.scaleX > 0.0)
					{
						// 縮小
						this.scaleX -= d;
						this.scaleY -= d;
						if (this.scaleX < 0.0)
						{
							this.scaleX = 0.0;
							this.scaleY = 0.0;
							setPosRnd();
						}
					}
					
					count--;
					if (count < 0)
					{
						step++;
					}
					break;
				case 1: 
					// 目標座標まで移動
					this.x += (tgt.x - this.x) / 3;
					this.y += (tgt.y - this.y) / 3;
					
					// 拡大
					this.scaleX += d;
					this.scaleY += d;
					
					if (this.scaleX >= 1.0)
					{
						this.scaleX = 1.0;
						this.scaleY = 1.0;
						this.x = tgt.x;
						this.y = tgt.y;
						count = waitCount;
						step++;
					}
					break;
				case 2: 
					// 時間待ち
					count--;
					if (count < 0)
					{
						count = waitCount;
						step = 0;
					}
			}
		}
	}

}